--[=[
    IMPORTANT: if you want to want to restart please just triple tap (twice)
]=]

-- Use this function to perform your initial setup
pongWorld = scene.default2d()
function setup()
    
    viewer.mode = FULLSCREEN_NO_BUTTONS
    pongWorld.camera:get(camera).orthoSize = 24
    pongWorld.pixelsPerUnit = 64
    pongWorld.camera:get(camera).clearColor = color(79, 49, 49)
    --pongWorld.physics2d.debugDraw = true
    pongWorld.physics2d.gravity = vec2(0)
    scene.main = pongWorld
    
    gameManager = pongWorld:entity("gameManager")
    gameManager:add(GameManager)
    
    local longPos = ((WIDTH/HEIGHT) * pongWorld.camera:get(camera).orthoSize) /2
    
    local paddlePosition = 2.5
    paddleSize = vec2(0.55, 4)
    paddle1 = pongWorld:entity("paddle1")
    paddle1.position = vec3(longPos - paddlePosition, 0,0)
    paddle1:add(MoveToFinger)
    paddle1:add(LockXAxis)
    paddle1:add(physics2d.body):box(paddleSize.x, paddleSize.y)
    paddle1.body2d.fixedRotation = true
    paddle1:add(BounceOffPaddle)
    paddle1.draw = function()
        style.fill(color(255)).shapeMode(CENTER)
        rect(0,0,paddleSize.x,paddleSize.y)
    end
    
    paddle2 = pongWorld:entity("paddle2")
    paddle2:add(MoveToFinger)
    paddle2.position = vec3(-(longPos - paddlePosition), 0,0)
    paddle2:add(LockXAxis)
    paddle2.draw = paddle1.draw
    paddle2:add(physics2d.body):box(paddleSize.x, paddleSize.y)
    paddle2:add(BounceOffPaddle)
    paddle2.body2d.fixedRotation = true
    
    net = pongWorld:entity("net")
    net.draw = function()
        style.strokeWidth(11).lineCap(SQUARE)

        local gapSize = 0.5
        local numLines = 35
        for i = 1, numLines do
            line(0,12 - (24 * (i -1 )/numLines) - (gapSize/2), 0, 12 - (24 * (i -1 )/numLines) - (24 * (1 )/numLines) + gapSize - (gapSize/2))
        end
    end
    
    ballDiameter = .5
    ball = pongWorld:entity("ball")
    ball:add(physics2d.body):box(ballDiameter, ballDiameter)
    ball.body2d.fixedRotation = true
    ball:add(BounceOnWall)
    ball.draw = function()
        style.strokeWidth(0)
        rect(0,0,ballDiameter)
    end
    ballSpeed = 16
    --ball.body2d.linearVelocity = ballSpeed * vec2(1,1)
    
    score1 = pongWorld:entity("score1")
    score1.score = 0
    score1.draw = function()
        style.fontSize(2).textAlign(LEFT | MIDDLE).sortOrder(1).strokeWidth(0).font("Rockwell")
        text(score1.score,0,0)
    end
    score1.uniformScale = 1.15
    score1.x = -4
    score1.y = 9
    
    score2 = pongWorld:entity("score2")
    score2.score = 0
    score2.draw = function()
        style.fontSize(2).textAlign(RIGHT | MIDDLE).sortOrder(1).strokeWidth(0).font("Rockwell")
        text(score2.score,0,0)
    end
    score2.uniformScale = 1.15
    score2.x = 4
    score2.y = 9
    
end

-- This function gets called once every frame
function draw()
    
    
end

