MoveToFinger = class()

function MoveToFinger:created()
    -- you can accept and set parameters here
    self.beginPos = nil
    self.touchid = nil
    self.gameManager = self.scene.gameManager:get(GameManager)
end

function MoveToFinger:leftSide(touch)
    return self.entity.x < 0 and touch.x < WIDTH / 2
end

function MoveToFinger:rightSide(touch)
    return self.entity.x > 0 and touch.x > WIDTH / 2
end

function MoveToFinger:touched(touch)

    
    if self.touchid == touch.id or self.touchid == nil then
        local cam = self.scene.camera:get(camera)
        if touch.began then
            if self:leftSide(touch) then
                self.touchid = touch.id
            elseif self:rightSide(touch) then
                self.touchid = touch.id
            end
            if not self.touchid then
                return false
            end
        elseif (touch.ended and touch.id == self.touchid) or (touch.cancelled and touch.id == self.touchid) then
            self.touchid = nil
            return false
        end
        

        
        if touch.id == self.touchid  and (self:leftSide(touch) or self:rightSide(touch)) then
            local _, yOffset = cam:screenToWorld(0, HEIGHT/2 + touch.delta.y, 0)
            self.entity.y = self.entity.y + yOffset
        
            local halfHeight = (self.scene.camera:get(camera).orthoSize / 2)
            if self.entity.y + paddleSize.y / 2 > halfHeight then
                self.entity.y = halfHeight - paddleSize.y / 2
            elseif self.entity.y - paddleSize.y / 2 < -halfHeight then
                self.entity.y = -halfHeight + paddleSize.y / 2
            end
        end
        return true
    end
end
